#!/bin/sh

# usage:
# save this shell file and decklink desktop video driver file in the same folder,such as /tmp/patch
# login as root
# change work dir: cd /tmp/pach
# run the shell file
# get the patched driver file in the same folder with "patched" prefix
# for desktopvideo driver 11.1.0 only





BASE_FOLDER=/tmp/bmd_rpms




WORK_DIR=`pwd`

clear
rm -rf patched_*.rpm  >/dev/null 2>&1

DRIVER_RPM_FILE=`find *.rpm 2>/dev/null `
if [ X${DRIVER_RPM_FILE} = "X" ];then
	echo -e "\n\n\n rpm driver file not found in the current folder!\n\n"
	exit
fi



if [ -d ${BASE_FOLDER} ];then
	rm -rf ${BASE_FOLDER} >/dev/null 2>&1
fi

yum install -y  rpm-build wget epel-release

yum install -y  "kernel-devel-uname-r == $(uname -r)"

#uniustall previous decklink drivers
RESULT=`rpm -qa | grep -i desktopvideo`
if [ "${RESULT}" ];then
	yum remove dkms -y
fi

#install DKMS
RESULT=`rpm -qa | grep -i dkms`
if [ X${RESULT} = "X" ];then
	yum install dkms -y
fi

#reinstall decklink drivers
yum install -y ${DRIVER_RPM_FILE}
PKG_NAME=`rpm -qa | grep desktopvideo`


echo "%_topdir  ${BASE_FOLDER}" >~/.rpmmacros
mkdir -p ${BASE_FOLDER}
mkdir -p ${BASE_FOLDER}/BUILDROOT
mkdir -p ${BASE_FOLDER}/BUILDROOT/${PKG_NAME}
mkdir -p ${BASE_FOLDER}/SPECS
mkdir -p ${BASE_FOLDER}/APPS


#download rpmrebuild
cd ${BASE_FOLDER}
wget  -P ${BASE_FOLDER}  https://excellmedia.dl.sourceforge.net/project/rpmrebuild/rpmrebuild/2.12-1/rpmrebuild-2.12.tar.gz 

if [ $? -eq 0 ];then
	tar -xvf ${BASE_FOLDER}/rpmrebuild-2.12.tar.gz -C  ${BASE_FOLDER}/APPS
else
	echo -e "\n\n\n\n\t  Download rpmrebuild error!!!\n\n\n\n"
	exit
fi



${BASE_FOLDER}/APPS/rpmrebuild.sh  -s ${BASE_FOLDER}/SPECS/$PKG_NAME.spec  $PKG_NAME
rpm2cpio ${WORK_DIR}/${DRIVER_RPM_FILE} |cpio -idv  -D ${BASE_FOLDER}/BUILDROOT/${PKG_NAME}


#patch source code
C_FILE=`find ${BASE_FOLDER} -name blackmagic_lib.c`
sed -i "s/access_ok(type, addr, size)/access_ok(addr, size)/g"  ${C_FILE}
C_FILE=`find ${BASE_FOLDER} -name bm_util.c`
sed -i "s/access_ok(type, addr, size)/access_ok(addr, size)/g"  ${C_FILE}

#rebuild rpm files
rpmbuild  -ba  ${BASE_FOLDER}/SPECS/$PKG_NAME.spec  

#copy builded rpm file
if [ -f ${BASE_FOLDER}/RPMS/x86_64/*.rpm ];then
	cp ${BASE_FOLDER}/RPMS/x86_64/*.rpm  ${WORK_DIR}/patched_${DRIVER_RPM_FILE}
fi

#remove temp files
cd ${WORK_DIR}
if [ -d ${BASE_FOLDER} ];then
	rm -rf ${BASE_FOLDER}
fi
	
#remove decklink drivers
yum remove dkms -y

#reinstall decklink drivers
yum install dkms -y

if [ -f ${WORK_DIR}/patched_${DRIVER_RPM_FILE} ];then
	yum install -y ${WORK_DIR}/patched_${DRIVER_RPM_FILE}
fi


echo -e "\n\n\n\t\tsucceeded!\n\n\n"
